from typing import NamedTuple


class Node(NamedTuple):
    index: int
    height: int


def get_biggest_square(array):
    array.append(0)
    stack = [Node(0, -1)]
    response = 0

    for i in range(0, len(array)):
        x_index = i
        while array[i] <= stack[-1].height:
            x_index = stack[-1].index
            previous_height = stack[-1].height
            stack.pop()
            area = previous_height * (i - x_index)

            if area > response:
                response = area

        stack.append(Node(x_index, array[i]))

    return response


def test_1():
    return list(map(int, '7 2 1 4 5 1 3 3'.split()))[1:]


assert 8 == get_biggest_square(test_1()), 'test 1'


def test_2():
    return list(map(int, '4 1000 1000 1000 1000'.split()))[1:]


assert 4000 == get_biggest_square(test_2()), 'test 2'


def test_3():
    return list(map(int, '3 2 1 2'.split()))[1:]


assert 3 == get_biggest_square(test_3()), 'test 3'


def test_4():
    return list(map(int, '8 2 1 2 0 3 2 2 3'.split()))[1:]


assert 8 == get_biggest_square(test_4()), 'test 4'

def test_5():
    return list(map(int, '437 586022928 377378740 690613952 225867626 306917784 531356340 827614886 681880045 582100510 233237589 975442612 160134119 493000974 766238083 787257395 134487037 85380181 646747818 257590546 421011097 596821268 420264133 360373367 841781707 684671223 557110590 503840656 714167599 542579335 91277221 300906333 529657317 96373041 831317725 344934405 145549306 522221786 827535812 791737240 407447411 73613039 880836289 603778618 983526321 976413276 666058757 902749463 821501431 795901880 549637416 258620812 25160508 427817126 987562106 832212814 448694819 813125374 654175044 439990218 467825942 116092869 130134976 566860188 152883117 530261858 220875810 446743436 753661220 285017561 112632447 794512492 376613002 609850592 585293204 745427324 238428298 4666381 791923777 926410814 11790995 658538813 916129359 337140456 933961725 354225858 714599226 556380933 241052156 798162747 302003402 16171002 558750337 650027558 950933892 480591209 576964250 408281975 753216381 898765687 420987473 248523285 40260525 447707936 521320976 402157264 5935882 989462204 965875480 631934237 534683700 356185131 152087011 701724428 960345240 985505749 413322875 400884981 233097795 681792615 494917989 149093034 589083252 56909194 173002064 303137040 869997230 22880346 553142205 774018015 220761451 974422672 259440234 372072681 166585174 543198176 153048769 738341973 483769297 722197595 726863977 518787754 445198568 456989563 115528376 31657736 368798193 302759918 656985777 371585003 927965937 169018093 967180840 269184243 285355245 844105583 494133141 445067033 925658242 502622492 910904467 664120848 562886535 983874009 232397294 272657819 720365756 241686732 643843997 649779879 639242083 605117563 237051800 771735501 127920632 280007644 981732073 942077313 927583062 340905937 741790918 974888714 656681329 151599318 300692353 889775605 946684800 119686865 422823906 292821135 315701483 868843689 642861704 863623156 838045828 97486062 469558743 636143917 179342094 332390863 70732837 554502134 276699730 3563707 522351461 967550029 424539592 540067969 571725705 940523899 243283817 900269594 271854597 199820533 368838627 336019467 605203710 890558956 734664538 228797679 673864713 599522955 102145447 13049915 677170764 240057299 223931308 456328602 728986422 449352178 691038910 334882907 984662787 623904870 229022433 466074234 237809735 365730368 645738012 627470085 569547398 497130460 838036397 579827315 554716029 211397358 362996677 663689030 553464636 500149436 619836302 42660207 335481344 651182827 520026516 162888220 26511376 864557205 962043267 431602011 67745928 247088023 579478886 650211723 204713858 481413588 484977295 7328756 974878786 399418378 939486348 511212053 451735952 695019769 595289363 867143960 66964494 435803121 771822589 377026299 267585255 2249793 231047473 904912186 504435141 606580589 619630505 296801268 536858568 760789876 217118478 946104901 395457079 86495989 421378896 406041683 29946553 258968986 725043221 962852956 328583324 974321337 601791422 171338820 668469281 506505679 86332994 641049024 852446383 215443060 879132091 432596727 932746164 552582466 595242674 930724018 581906846 101933362 264821582 291332958 155890163 117933430 549535441 617281370 864369393 443848279 94060003 298773861 780187450 265164745 272493502 247372287 646790666 586277013 97489066 549225019 244244787 839534151 706678111 773642605 209445726 981268316 358294615 625879870 628129664 859177137 764089323 268524465 875105054 494735559 791536828 328395396 89185272 306303751 252408652 647865731 734361721 155740617 561782300 591728853 850697840 575741061 538594017 867177342 841498678 443290101 614628922 283098203 789603882 875936876 516985901 369432284 584875345 464007436 896604163 829350327 381932793 977175467 907899486 489806331 591739694 856561276 147894235 303784398 421717829 971253271 588534641 452904035 896752315 990812318 289586179 69773629 334938374 607431877 854804165 501594831 87871844 185360911 734585930 978830718 818364869 525042980 298685585 508131311 489399627 847694242 473574112 101703776 960880914 724970237 993494702 868599757 363335316 154872144 483267540 572452813 878756564 131165216 779030947 513392668 669133285 230915586 822644439 673342279 249083340 787677358 654854699 496353378 939643479 554272400 837370604 626974486 502911362 19897263 389329548 974204893 438212328 334816491'.split()))[1:]


assert 9489213544 == get_biggest_square(test_5()), 'test 5'
